﻿using UnityEngine;
using HarmonyLib;

public class GarbageSuckerFix : Mod
{
    Harmony harmony;
    public void Start()
    {
        harmony = new Harmony("com.aidanamite.GarbageSuckerFix");
        harmony.PatchAll();
        Log("Garbage suckers have been patched!");
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(harmony.Id);
        Log("Garbage suckers have been unpatched!");
    }
}

[HarmonyPatch(typeof(BlockQuad), "AcceptsBlock")]
public class Patch_Accept
{
	static void Postfix(ref BlockQuad __instance, ref Item_Base blockItem, ref bool __result)
	{
		if (blockItem.UniqueName == "placeable_garbagesucker")
		{
			if (Mathf.Abs(__instance.transform.rotation.x) > 0.1 || Mathf.Abs(__instance.transform.rotation.y) > 0.1 || Mathf.Abs(__instance.transform.rotation.z) > 0.1 || Mathf.Abs(__instance.transform.rotation.w) < 0.9)
            {
				__result = false;
				return;
            }
			Vector3 lp = ComponentManager<Raft>.Value.transform.InverseTransformPoint(__instance.transform.position);
			foreach (Block block in BlockCreator.GetPlacedBlocks())
				if (block is Block_Foundation_ItemNet && (lp - ComponentManager<Raft>.Value.transform.InverseTransformPoint(block.transform.position)).magnitude < 0.1)
				{
					__result = true;
					return;
				}
			__result = false;
		}
	}
}